// EventListTableModel.java

import java.io.*;
import java.util.StringTokenizer;
import javax.swing.table.*;
import javax.sound.midi.Track;

/**
	CxgXg̏ڍׂێTableModel

	@version	0.01 11/18/2000
	@author		Takahiro Shigemoto
*/
public class EventListTableModel extends AbstractTableModel
{
	private final String[][] data;

	private static final String columnName[] = {
		"track", "tick", "channel", "event", "data1", "data2"
	};

	public EventListTableModel(Track track, int track_number) throws IOException
	{
		// f[^i[pz̏
		data = new String[columnName.length][track.size()];

		// Track̎擾
		StringWriter s_writer = new StringWriter();
		new TrackDumper(track, track_number).dump(s_writer);

		// Track̉
		int row_index = 0;

		BufferedReader reader = new BufferedReader(new StringReader(s_writer.toString()));
		for(int i=0; i<track.size(); i++)
		{
			String buf = reader.readLine();
			StringTokenizer token = new StringTokenizer(buf, ",");

			int col_index = 0;
			while(token.hasMoreTokens())
			{
				data[col_index][row_index] = token.nextToken();
				col_index++;
			}
			if(data[columnName.length - 1][row_index] == null)
			{
				data[columnName.length - 1][row_index] = "";
			}

			row_index++;
		}
	}

	public int getColumnCount()
	{
		return(columnName.length);
	}

	public String getColumnName(int columnIndex)
	{
		return(columnName[columnIndex]);
	}

	public int getRowCount()
	{
		return(data[0].length);
	}

	public Object getValueAt(int rowIndex, int columnIndex)
	{
		return (data[columnIndex][rowIndex]);
	}

	public Class getColumnClass(int columnIndex)
	{
		return(getValueAt(0, columnIndex).getClass());
	}

	public boolean isCellEditable(int rowIndex, int columnIndex)
	{
		return(false);
	}
}