// TrackDumper.java

import java.io.*;
import javax.sound.midi.*;

/**
	gbNwXg[ɏo͂NX
	@version	0.02 11/18/2000
	@author		Takahiro Shigemoto
*/
public class TrackDumper
{
	// ΏۃgbN
	Track track;
	int track_number;

	// VXeŗL̉sR[h
	String line_separator = System.getProperty("line.separator");

	// gbNƃgbNԍw肵TrackDump\z
	public TrackDumper(Track track, int track_number)
	{
		this.track = track;
		this.track_number = track_number;
	}

	// wXg[ɃCxgo
	public void dump(Writer writer) throws IOException
	{
		long ticks = track.ticks();

		for(int i=0; i<track.size(); i++)
		{
			// ԂMidiCxg擾
			MidiEvent midi_evt = track.get(i);

			// ݂Tickl̎擾
			long current_tick = midi_evt.getTick();

			// ݂TicklɂMidibZ[Wo
			MidiMessage msg = midi_evt.getMessage();

			// bZ[Wo
			dumpMessage(msg, writer, ticks, current_tick);
		}
	}

	// wXg[ɃbZ[Wo
	private void dumpMessage(MidiMessage msg, Writer writer, long ticks, long current_tick) throws IOException
	{
		byte[] byte_midi_msg = msg.getMessage();

		// Xe[^XoCgA`lԍo
		int status_byte = byteToUnsignedByte(byte_midi_msg[0]);
		int channel = getChannelFromStatusByte(status_byte);

		if(msg instanceof ShortMessage)
		{
			// bZ[Wɕtlo
			int value1 = 0, value2 = 0;
			if(byte_midi_msg.length == 2)
			{
				value1 = byteToUnsignedByte(byte_midi_msg[1]);
			}
			else if(byte_midi_msg.length == 3)
			{
				value1 = byteToUnsignedByte(byte_midi_msg[1]);
				value2 = byteToUnsignedByte(byte_midi_msg[2]);
			}

			// `lbZ[Wo
			String event_name = statusByteToMsgName(status_byte, value1);

			// gbÑCxg\
			writer.write(track_number + "," + current_tick + "/" + ticks + "," + channel + "," + event_name + "," + value1 + "," + value2);

			writer.write(line_separator);
			writer.flush();
		}
		else if(msg instanceof SysexMessage)
		{
			// Sysx̃f[^o
			SysexMessage sysex_msg = (SysexMessage)msg;
			byte[] byte_sysex_msg = sysex_msg.getMessage();
			byte[] sysx_data = sysex_msg.getData();

			writer.write(track_number + "," + current_tick + "/" + ticks + ",n/a" + ",SYSX," + Integer.toHexString(byteToUnsignedByte(byte_sysex_msg[0])).toUpperCase() + " ");
			for(int i=0; i<sysx_data.length; i++)
			{
				writer.write(Integer.toHexString(byteToUnsignedByte(sysx_data[i])).toUpperCase() + " ");
			}

			writer.write(line_separator);
			writer.flush();
		}
		else if(msg instanceof MetaMessage)
		{
			// MetaMessagẽf[^o
			MetaMessage meta_msg = (MetaMessage)msg;
			byte[] byte_meta_msg = meta_msg.getMessage();
			byte[] meta_data = meta_msg.getData();

			writer.write(track_number + "," + current_tick + "/" + ticks + ",n/a" + ",META," + Integer.toHexString(byteToUnsignedByte(byte_meta_msg[0])).toUpperCase() + " ");
			for(int i=0; i<meta_data.length; i++)
			{
				writer.write(Integer.toHexString(byteToUnsignedByte(meta_data[i])).toUpperCase() + " ");
			}

			writer.write(line_separator);
			writer.flush();
		}
		else
		{
			writer.write(msg.toString());
			writer.write(line_separator);
			writer.flush();	
		}
	}

	// byte  unsigned byte  int̕ϊ\bh
	private int byteToUnsignedByte(byte b)
	{
		if(b < 0)
			return(256 + b);
		else
			return(b);
	}

	// Xe[^XoCg  `lbZ[W
	private String statusByteToMsgName(int status_byte, int value1)
	{
		switch (status_byte / 16)
		{
			case 8:
				return("NOTE_OFF");
			case 9:
				return("NOTE_ON");
			case 10:
				return("POLYFONIC_KEY_PRESSURE");
			case 11:
				if(value1 >= 120)
					return("CHANNEL_MODE_MESSAGE");
				else
					return("CONTROL_CHANGE");
			case 12:
				return("PROGRAM_CHANGE");
			case 13:
				return("CHANNEL_PRESSURE");
			case 14:
				return("PITCH_BEND_CHANGE");
			default:
				return("" + status_byte);
		}
	}

	// Xe[^XoCg  `lԍ
	private int getChannelFromStatusByte(int status_byte)
	{
		return(status_byte % 16 + 1);
	}
}